#include <bits/stdc++.h>

using namespace std;

int main()
{
    long long n;
    long long m;
    cin>>n>>m;
    string k;
    cin>>k;
    long long x;
    long long y;
    for (long long i=0;i<m;i++){
        cin>>x>>y;
        if ((y-x+1)%2==0){
            cout<<(y-x+1)*(y-x+1)/4<<endl;
        }
        else{
            cout<<(y-x)*(y-x+2)/4<<endl;
        }
    }
    return 0;
}